--GroupFinderButton Mixin!


Q_C_GroupFinderButtonMixin = {}

local finder = Q_C_GroupFinderButtonMixin


	local oldold = C_LFGList.CanCreateQuestGroup
	local function CanCreateQuestGroup(questID, ...)
		local o = oldold(questID, ...)
		if o then
			return o
		end
		local info = questID and C_QuestLog.GetQuestTagInfo(questID)
		if info.worldQuestType == 6 then
			return true, true
		end
	end

	local op = {
		Left = "Right",
		Right = "Left",
		Bottom = "Top",
		Top = "Bottom",
	}

	local categories = {}
	local function GetQueueInfo(index)
		local lfgDungeonIDs = C_LFGInfo.GetAllEntriesForCategory(LE_LFG_CATEGORY_LFD)

		local total = 0
		for i = 1, 7 do
			local ids = C_LFGInfo.GetAllEntriesForCategory(i)
			categories[i] = categories[i] or {}
			wipe(categories[i])
			tinsert(categories[i], ids)
			total = total + #ids
		end

		return id and categories[id] or categories, id and #categories[id] or total
	end

	local function QuickJoinToastMixin_OnEnter(button, questID, queued)
		if not questID then
			return --print(button, questID)
		end
		local canMake = C_LFGList.CanCreateQuestGroup(questID)

		--local ids, numIDs = GetQueueInfo(index)

		local looking = queued

		if  looking or canMake and looking then
			QueueStatusMinimapButton:GetScript("OnEnter")(button)


			local x, y = button:GetCenter()
			local w, h = UIParent:GetSize()
			local half_w, half_h = w/2, h/2
			local ver, hor = "Bottom", "Left"

			if not (y and x and half_h and half_w) then return end

			if y >= half_h then
				ver = "Top"
			end
			if x >= half_w then
				hor = "Right"
			end
			QueueStatusFrame:ClearAllPoints()
			QueueStatusFrame:SetPoint(ver..hor, button, op[ver]..op[hor])

			local eScale = QueueStatusFrame:GetEffectiveScale()
			if eScale ~= 1 then
				local scale = 1
				self.scale = scale;  -- Saved in case it needs to be re-calculated when the parent's scale changes.
				local parent = QueueStatusFrame:GetParent();
				if ( parent ) then
					scale = scale / parent:GetEffectiveScale()
				end
				QueueStatusFrame:SetScale(scale);
			end
			QueueStatusFrame:SetFrameStrata("TOOLTIP")
			QueueStatusFrame:SetFrameLevel(100)
		else
			GameTooltip:SetOwner(button, "ANCHOR_RIGHT");
			GameTooltip:SetText(button.tooltip or "")
			GameTooltip:AddLine(button.tooltip2 or "")
			GameTooltip:Show()
		end
	end

	local function GetInstanceIDByName(zoneID, name)
		local dungeonEntrances = C_EncounterJournal.GetDungeonEntrancesForMap(zoneID)
		for i, b in pairs(dungeonEntrances) do
			if b.name == name then
				return b.journalInstanceID
			end
		end
	end



--let's make the eye look around and blink at random!
b 
local actionStep = 8

local updateInterval = 1/8 --fraction of a second: think Frame Per Second

local function secs()
	return GetTimePreciseSec()
end
local cTime = secs()
local lastElapsed = -updateInterval

local lastAction

local active = 1
local actions = {{count = 0, repeatCount = 0, maxRepeat = 6, sequenceLength = 8, uppercount = 0, lowercount = 0}, {count = 0, repeatCount = 0, maxRepeat = 3, sequenceLength = 9}, {count = 0, repeatCount = 0, maxRepeat = 2, sequenceLength = 3}, {count = 0, repeatCount = 0, maxRepeat = 6, sequenceLength = 8, uppercount = 0, lowercount = 0}}

local coords = {
	x = { --x
		current = 0,
		movement = 1,
		range = 40,
		returnRate = 0
	},
	y = {--y
		current = 0,
		movement = 1,
		range = 75,
		returnRate = 0
	},
}

local xRange = (coords.x.range / actions[1].sequenceLength) * 10
local yRange = (coords.y.range / actions[1].sequenceLength) * 10

local lastUpdate

local function Update(index)
	local action = actions[index]
	if action.repeatCount > action.maxRepeat then
		action.repeatCount = 0
		actionStep = 0
		lastUpdate = nil
		return action.repeatReset()
	elseif (actionStep > action.sequenceLength ) or (lastAction == index) then --ether it's finishing, or it's the last action to have happened.
		action.repeatCount = action.repeatCount + 1
		actionStep = 0
		lastUpdate = nil
		return action.reset()
	else
		if lastUpdate ~= index then
			--reset me
			action.count = 0
			action.repeatCount = 0
		end
		lastUpdate = index
		action.count = action.count > action.sequenceLength and 1 or action.count + 1
		return action.update()
	end
end

local nextAction


local look = actions[1]
do
	look.update = function()
		coords.x.current = math.min(coords.x.range, math.max(-coords.x.range, (coords.x.current + coords.x.movement) ))
		coords.y.current = math.min(coords.y.range, math.max(-coords.y.range, (coords.y.current + coords.y.movement) ))
	end

	look.reset = function()
		actionStep = 0
		lastAction = 1
		active = (random(1, 2) == 2) and 3 or 1
		
		if active == 1 then
			lastAction = 3
			coords.x.movement = random(-xRange, xRange)/10
			coords.y.movement = random(-yRange, yRange)/10
		end
		
		coords.x.returnRate = coords.x.current/5
		coords.y.returnRate = coords.y.current/5
		look.uppercount, look.lowerCount = 1, 1

		return  Update(active)
	end

	look.repeatReset = function()
		lastAction = 1
		active = 3
		actionStep = 0
		look.count = 0
		look.uppercount, look.lowerCount = 1, 1
		return  Update(3)
	end
end

local blink = actions[2]
do
	blink.update = function()
		coords.x.current = 0
		coords.y.current = 0
		return "Blinking"
	end

	blink.reset = function()
		blink.count = 0
		active = random(1, 2)
		actionStep = 0
		lastAction = 2
		if active == 1 then
			coords.x.movement = random(-xRange, xRange)/10
			coords.y.movement = random(-yRange, yRange)/10
		end
		return  Update(active)
	end

	blink.repeatReset = function()
		lastAction = 2
		active = 1
		blink.count = 0
		return Update(1)
	end
	blink.reset()
end

local center = actions[3]
do
	center.update = function()
		coords.x.current = coords.x.current - (coords.x.returnRate)
		coords.y.current = coords.y.current - (coords.y.returnRate)
		return "Centering"
	end

	center.reset = function()
		lastAction = 3
		actionStep = 0
		coords.x.movement = random(-xRange, xRange)/10
		coords.y.movement = random(-yRange, yRange)/10

		active = random(1,3)
		if active == 3 then
			lastAction = nil
			coords.x.movement = 0
			coords.y.movement = 0
		end
		return  Update(active)
	end

	center.repeatReset = function()	
		
		lastAction = 3
		actionStep = 0
		coords.x.movement = random(-xRange, xRange)/10
		coords.y.movement = random(-yRange, yRange)/10
		active = random(1,2)
		return  Update(active)
	end
end

local mouseIsOver
local function watchCursor(self, justCenter)
	if MouseIsOver(self) or MouseIsOver(self:GetParent()) or MouseIsOver(Q_C.pin) or MouseIsOver(Q_C.coordText) or MouseIsOver(Q_C.Notify) then
		local curX, curY = GetCursorPosition()
		local sX, sY, w, h = self:GetScaledRect()
		sX = sX + (w/2)
		sY = sY + (h/2)
		local s = self:GetScale()
		coords.x.current = -(curX - sX + 7) * 10
		coords.y.current = (curY - sY) * 10
		mouseIsOver = true
		look.count = 0
		blink.count = 0
		center.count = 0
		return true
	elseif  mouseIsOver == true then
		mouseIsOver = nil
		lastAction = nil
		actionStep = 0
		coords.x.movement = random(-xRange, xRange)/10
		coords.y.movement = random(-yRange, yRange)/10
		reset = true
		active = 3--random(1,3)
		return Update(active)
	end

end

local update = 0
local function AnimateTexCoords(self)
	local texture = self.texture
	local _time = secs()
	local seconds = _time - cTime
	if seconds - lastElapsed  <= updateInterval then return end
	lastElapsed = seconds
	
	update = update < actionStep and update + 1 or 1
	--only update if enough time has passed
	if update < 1 then return else update = 0 end 

	local self = texture:GetParent()

	actionStep = actionStep + 1

	if watchCursor(self) ~= true then
		Update(active)
	end

	local distance = sqrt(coords.x.current^2 + coords.y.current^2, 2)

	local angle = (math.atan2(coords.y.current, coords.x.current))
	
	local maxX = coords.x.range * cos(angle)
	local maxY = coords.y.range * sin(deg(angle))
	maxX, maxY = math.abs(tostring(maxX) ~= "-nan(ind)" and maxX or 0), math.abs(tostring(maxY) ~= "-nan(ind)" and maxY or 0)
	
	coords.x.current = math.min(maxX, math.max(-maxX, coords.x.current))
	coords.y.current = math.min(maxY, math.max(-maxY, coords.y.current))

	local pX = coords.x.current / (100)
	local pY = coords.y.current / (100)

	local aX, bX, aY, bY = 0 + pX/1.4, 1 + pX/1.4, 0 + pY/2.3, 1 + pY/2.3
	local saX, sbX, saY, sbY = 0 + pX/6, 1 + pX/6, 0 + pY/6, 1 + pY/6

	local x, y = coords.x.current, coords.y.current
	
	local upperPercent, lowerPercent = 1, 1
	
	local percent =(y/coords.y.range)
	
	upperPercent = (percent <= 0) and math.floor((5 * math.abs(percent))+.25) or 1
	lowerPercent = (percent >= 0) and math.floor((5 * math.abs(percent))+.25) or 1

	self.pupil:SetTexCoord(aX, bX, aY, bY)
	self.shine:SetTexCoord(saX, sbX, saY, sbY)
	
	local up = (blink.count == 0) and ((upperPercent ~= 0 ) and upperPercent) or math.min(9, math.max(1, blink.count))
	local low = (blink.count == 0) and ((lowerPercent ~= 0 ) and lowerPercent) or math.min(9, math.max(1, blink.count))
	
	self.upper:SetTexture(Q_C.TexturePath.."Eye\\eyelids\\upper"..(up))
	self.lower:SetTexture(Q_C.TexturePath.."Eye\\eyelids\\lower"..(low))
end

local isAnim

local function EyeTemplate_StartAnimating(eye)
	if not isAnim then
		isAnim = true
		eye:SetScript("OnUpdate", AnimateTexCoords);
	end
end

local function EyeTemplate_StopAnimating(eye)
	active = 3
	lastAction = nil
	actions[2].count = 0
	Update(active)
	isAnim = nil
	
	
	eye:SetScript("OnUpdate", function()
		if actions[3].count <= actions[3].sequenceLength then
	--coords.x.current = coords.x.current - (coords.x.returnRate)
			--coords.y.current = coords.y.current - (coords.y.returnRate)
			Update(3)
			--return "Centering"
		else
			eye:SetScript("OnUpdate", nil)
			print(123)
		end
	end)
	eye.pupil:SetTexCoord(0,1, 0, 1)
	eye.shine:SetTexCoord(0,1, 0, 1)
	eye.upper:SetTexture(Q_C.TexturePath.."Eye\\eyelids\\upper"..1)
	eye.lower:SetTexture(Q_C.TexturePath.."Eye\\eyelids\\lower"..1)
end


-- LFG
local categories = {
	LE_LFG_CATEGORY_LFD,
	LE_LFG_CATEGORY_RF,
	LE_LFG_CATEGORY_SCENARIO,
	LE_LFG_CATEGORY_LFR,
	LE_LFG_CATEGORY_FLEXRAID,
	LE_LFG_CATEGORY_WORLDPVP,
	LE_LFG_CATEGORY_BATTLEFIELD,
}

local function shouldShowAndOrAnimate()
	local animateEye;
	local showButton
	--Try each LFG type

	for category=1, NUM_LE_LFG_CATEGORYS do
		local mode, submode = GetLFGMode(category);
		if  mode and submode ~= "noteleport"  then
			showButton = true
			if ( mode == "queued" ) then
				animateEye = true
			end
		end
		local ids = C_LFGInfo.GetAllEntriesForCategory(category)
		for i, id in ipairs(ids) do
			local inParty, joined, queued, noPartialClear, achievements, lfgComment, slotCount, category,
			leader, tank, healer, dps = GetLFGInfoServer(category, id);
			if queued == true then
				showButton = true
				animateEye = true
			end
		end
	end

	--Try LFGList applications
	local apps = C_LFGList.GetApplications();
	for i=1, #apps do
		local _, appStatus = C_LFGList.GetApplicationInfo(apps[i]);
		if ( appStatus == "applied" or appStatus == "invited" ) then
			showButton = true
			if ( appStatus == "applied" ) then
				animateEye = true;
			end
		end
	end

	--Try all PvP queues
	for i=1, GetMaxBattlefieldID() do
		local status, mapName, teamSize, registeredMatch, suspend = GetBattlefieldStatus(i);
		if ( status and status ~= "none" ) then
			showButton = true
			if ( status == "queued" and not suspend ) then
				animateEye = true;
			end
		end
	end

	--Try all World PvP queues
	for i=1, MAX_WORLD_PVP_QUEUES do
		local status, mapName, queueID = GetWorldPVPQueueStatus(i);
		if ( status and status ~= "none" ) then
			showButton = true
			if ( status == "queued" ) then
				animateEye = true;
			end
		end
	end

	-- Try LFGList entries
	local isActive = C_LFGList.HasActiveEntryInfo();
	
	-- Try PvP Role Check
	local inProgress, _, _, _, _, isBattleground = GetLFGRoleUpdate();

	-- Try PvP Ready Check
	local readyCheckInProgress, readyCheckIsBattleground = GetLFGReadyCheckUpdate();
	
	-- Pet Battle PvP Queue
	local pbStatus = C_PetBattles.GetPVPMatchmakingInfo();
	
	if ( inProgress and isBattleground ) 
	or ( readyCheckInProgress and readyCheckIsBattleground )
	or ( CanHearthAndResurrectFromArea() )
	or (isActive) 
	or (pbStatus) then
		showButton = true
	end

	if (pbStatus and ( pbStatus == "queued" )) or isActive then
		animateEye = true;
	end

	return showButton, animateEye
end

	local accept
	local dungeonTitle = ""
	local _text = ""
	_G.StaticPopupDialogs.ConfirmDungeonEntry = {
		text = _text,
		button1 = OKAY,
		button2 = CANCEL,
		timeout = 0,
		whileDead = true,
		hideOnEscape = true,
		--hasEditBox = true,
		OnAccept = function(self, data)
			if accept then
				accept()
			end
		end,
		OnCancel = function(self, data)
			
		end,

		--enterClicksFirstButton = true,
		--OnCancel = function() show() end, -- Need to wrap it so we don't pass |self| as an error argument to show().
		preferredIndex = STATICPOPUP_NUMDIALOGS,
	}

	local function GetDisplayNameFromCategory(category)
		if (category == LE_LFG_CATEGORY_BATTLEFIELD) then
			local brawlInfo;
			if (C_PvP.IsInBrawl()) then
				brawlInfo = C_PvP.GetActiveBrawlInfo();
			else
				brawlInfo = C_PvP.GetAvailableBrawlInfo();
			end
			if (brawlInfo and brawlInfo.canQueue and brawlInfo.name) then
				return brawlInfo.name;
			end
		end

		if (category == LE_LFG_CATEGORY_SCENARIO) then
			local scenarioIDs = C_LFGInfo.GetAllEntriesForCategory(category)
			for i, scenID in ipairs(scenarioIDs) do
				if (not C_LFGInfo.HideNameFromUI(scenID)) then
					local instanceName = GetLFGDungeonInfo(scenID);
					if(instanceName) then
						return instanceName;
					end
				end
			end
		end

		return LFG_CATEGORY_NAMES[category];
	end

	local on, off = {1,1,1,1}, {1,0,0,1}
	local canCreateGroup = {}
	function Q_C:ShowGroupButton(questID)
		local queued = shouldShowAndOrAnimate()
		
		canCreateGroup[questID or 0] = questID and canCreateGroup[questID] or questID and CanCreateQuestGroup(questID) or false
		local state = UnitInAnyGroup("player") == true and true or queued or canCreateGroup[questID]
		if state and not self.groupButton then
			self.groupButton = CreateFrame("BUTTON", "Q_C-GroupFinder", self, "Q_C-EyeHighlightAnim");
			self.groupButton:SetHitRectInsets(3, 25 , 30, 30)
			self.groupButton:ClearAllPoints()
			self.groupButton:SetFrameStrata("LOW")
			self.groupButton:SetPoint("Top", self.pin.border, 0, -3)
			self.groupButton:SetPoint("Bottom", self.pin.border)
			self.groupButton:SetPoint("Right", self.pin.border, "Center")
			self.groupButton:SetPoint("Left", self.pin.border)

			local w, h = self. :GetSize()

			self.groupButton:SetSize(w/2,h)
			self.groupButton:SetNormalTexture(self.TexturePath.."item")
			self.groupButton:GetNormalTexture():SetTexCoord(1,0,1,0)
			self.groupButton:SetPushedTexture(self.TexturePath.."item-pushed")
			self.groupButton:GetPushedTexture():SetTexCoord(1,0,1,0)
			--self.groupButton:SetHighlightTexture(self.TexturePath.."lfg-highlight")

			local eyeHandler = CreateFrame("Frame", nil, self.groupButton)
			eyeHandler:SetPoint("Right", self.groupButton, "Center", 5,0)--("Right", self.groupButton, "Center", 10,0)
			eyeHandler:SetSize(30, 35)
			self.groupButton.green = eyeHandler:CreateTexture(nil, "BACKGROUND")
			
			self.groupButton.icon = eyeHandler--self.groupButton:CreateTexture(nil, "OVERLAY")
			-- self.groupButton.Eye = self.groupButton.icon
			-- self.groupButton.icon:SetPoint("Right", self.groupButton, "Center", 10,0)
			-- self.groupButton.icon:SetSize(35, 35)
			--self.groupButton.icon:SetTexture("Interface\\LFGFrame\\LFG-Eye")

			self.groupButton.Highlight:SetPoint("Center", self.groupButton.icon)

			self.groupButton.green:SetAllPoints(eyeHandler)

			--self.groupButton.green:SetAllPoints(self.groupButton.icon)
			self.groupButton.green:SetTexture(self.TexturePath.."Eye\\green")
			self.groupButton.pupil = eyeHandler:CreateTexture(nil, "ARTWORK")
			self.groupButton.pupil:SetTexture(self.TexturePath.."Eye\\pupil")
			self.groupButton.shine = eyeHandler:CreateTexture(nil, "ARTWORK")
			self.groupButton.shine:SetTexture(self.TexturePath.."Eye\\shine")
		--	self.groupButton.shine:SetBlendMode("BLEND")
			self.groupButton.shine:SetAlpha(.75)

			self.groupButton.shine:SetPoint("Center")
			self.groupButton.shine:SetSize(17.5, 17.5)
			self.groupButton.pupil:SetPoint("Center")
			self.groupButton.pupil:SetSize(17.5, 17.5)
			
			self.groupButton.upper = eyeHandler:CreateTexture(nil, "OVERLAY")
			self.groupButton.upper:SetTexture(self.TexturePath.."Eye\\eyelids\\upper1")
			self.groupButton.upper:SetAllPoints(eyeHandler)

			self.groupButton.lower = eyeHandler:CreateTexture(nil, "OVERLAY")
			self.groupButton.lower:SetTexture(self.TexturePath.."Eye\\eyelids\\lower1")
			self.groupButton.lower:SetAllPoints(eyeHandler)
			
			self.groupButton.texture = self.groupButton.icon
			self.groupButton:RegisterForClicks("AnyUp")
			self.groupButton:SetScript("OnClick", function(self, btn, ...)
				self.DropDown = self.DropDown or QueueStatusMinimapButton.DropDown
				if not InCombatLockdown() then
				
					local show, animate = shouldShowAndOrAnimate()
					if btn == "RightButton" then
						local inBattlefield, showScoreboard = QueueStatus_InActiveBattlefield();
						if IsInLFDBattlefield() then
							inBattlefield = true;
							showScoreboard = true;
						end
						local lfgListActiveEntry = C_LFGList.HasActiveEntryInfo();
						if ( inBattlefield ) then
							if ( showScoreboard ) then
								return TogglePVPScoreboardOrResults();
							end
						elseif ( lfgListActiveEntry ) then
							return LFGListUtil_OpenBestWindow(true);
						else
							--See if we have any active LFGList applications
							local apps = C_LFGList.GetApplications();
							for i=1, #apps do
								local _, appStatus = C_LFGList.GetApplicationInfo(apps[i]);
								if ( appStatus == "applied" or appStatus == "invited" ) then
									--We want to open to the LFGList screen
									LFGListUtil_OpenBestWindow(true);
									return;
								end
							end
						end
						PVEFrame_ToggleFrame("GroupFinderFrame", "LFDParentFrame");
						return
					else
						if (animate == true) then
							QueueStatusDropDown_Show(self.DropDown, self:GetName())
							local p1, p2 = Q_C.SelectProperSide(self)
							DropDownList1:ClearAllPoints()
							DropDownList1:SetPoint(p2, self, p1)					
						elseif canCreateGroup[self.questID] == true then
							local isFromGreenEyeButton = true;
							LFGListUtil_FindQuestGroup(self.questID, isFromGreenEyeButton)
						else
							local info = self.questID and C_QuestLog.GetQuestTagInfo(self.questID)
							if info and WORLD_QUEST_TYPE_DUNGEON_TYPES[info.worldQuestType] then
								local x,y, zoneID = Questra:GetQuestLocation(self.questID, true)
								local title, factionID, capped, factionName = Q_C.getFactionInfo(self.questID)
								local name = string.split(":", title )
								local dungeonID = GetInstanceIDByName(zoneID, name)
								local isLocked = (GetLFGInviteRoleAvailability(dungeonID) == true) and "   You are already locked to "..name.."."
								_G.StaticPopupDialogs.ConfirmDungeonEntry.text = isLocked or "Are you sure you want to queue for "..name.."?" ..isLocked
								accept = function()
									if dungeonID and isLocked == nil then
										LFDFrame_DisplayDungeonByID(dungeonID);
										PVEFrame_ShowFrame("GroupFinderFrame", LFDParentFrame);
										do--can i auto-queue? lets find out!
											local list = {}
											local count = 0
											local last
											for i = 1, NUM_LFD_CHOICE_BUTTONS do
												local button = _G["LFDQueueFrameSpecificListButton"..i];
												if GetLFGDungeonInfo(button.id) == name then
													count = count + 1
													if count == 2 and last then
														tremove(list, 1)
														LFGDungeonList_SetDungeonEnabled(last, false)
													end
													tinsert(list, button.id)
													LFGDungeonList_SetDungeonEnabled(button.id, true)
													last = button.id
												end
											end
											if #list > 0 then
												LFDQueueFrame_Join()
											end
											HideUIPanel(PVEFrame)
										end--i can auto-queue! i fully expect Blizzard to kill this one day.
									end
								end
								StaticPopup_Show("ConfirmDungeonEntry")
							else
							--	local isFromGreenEyeButton = true;
							--	LFGListUtil_FindQuestGroup(self.questID, isFromGreenEyeButton)
							end
						end
					end
				end
			end)

			local high = eyeHandler:CreateTexture(nil, "HIGHLIGHT")
			high:SetTexture(self.TexturePath.."lfg-highlight")


			eyeHandler:EnableMouse(false)
			
			high:SetBlendMode("ADD")
			high:ClearAllPoints()

			high:SetAlpha(.5)
			high:SetPoint("Left", self.groupButton, 1, 0)
			local w,  h = self.groupButton:GetSize()
			high:SetSize(w, h)
			self.groupButton:HookScript("OnMouseDown", function()
				self.groupButton.icon:SetSize(25, 45)
				self.groupButton.icon:SetPoint("Right", self.groupButton, "Center", 4,0)
				high:SetPoint("Left", 5, 0)
				high:SetAlpha(.25)
			end)

			self.groupButton:HookScript("OnMouseUp", function()
				self.groupButton.icon:SetSize(30, 35)
				self.groupButton.icon:SetPoint("Right", self.groupButton, "Center", 5,0)
				high:SetPoint("Left", 1, 0)
				high:SetAlpha(.5)
			end)


			self.groupButton:SetScript("OnEnter", function()
				local show, animate = shouldShowAndOrAnimate()
				QuickJoinToastMixin_OnEnter(self.groupButton, self.groupButton.questID, show)
				
				if not animate then
					self.groupButton:SetScript("OnUpdate", function() watchCursor(self.groupButton, true) end)
				end
				
			end)

			self.groupButton:SetScript("OnLeave", function()
				GameTooltip:Hide()
				QueueStatusFrame:Hide()
			end)
			
			hooky = self.groupButton

			
		end


		local showGroup, shouldAnimate = shouldShowAndOrAnimate()
		if self.groupButton then
			if shouldAnimate then					
				EyeTemplate_StartAnimating(self.groupButton)
			else
				EyeTemplate_StopAnimating(self.groupButton)
			end
			self.groupButton.glowLocks = QueueStatusMinimapButton.glowLocks
			QueueStatusMinimapButton_UpdateGlow(self.groupButton)
		end
		
		local textureInfo = LFG_EYE_TEXTURES["default"]
		if self.groupButton and not InCombatLockdown() then
			self.groupButton.questID = questID
			local shouldShow = ((canCreateGroup[questID] == true) or (UnitInAnyGroup("player") == true) or (queued)) and true or nil
			self.groupButton.tooltip, self.groupButton.tooltip2  = (((canCreateGroup[questID] == true) and (not inGroup)) and (queued)) and "You are looking for a group." --and you need to be in a group for this quest.
			or ((canCreateGroup[questID] == true) and (not inGroup))and "This task suggests a group." --and you aren't in one yet.
			or ((UnitInAnyGroup("player") == true)) and "You are in a group, but this task does not require one", --some quests won't provide credit if you are in the wrong type of group...
			(((canCreateGroup[questID] == true) and (not inGroup)) and (queued)) and "Be patient..."
			or ((canCreateGroup[questID] == true) and (not inGroup)) and "Left click to find one."
			or (UnitInAnyGroup("player") == true) and "Right click to leave the group."
			
			self.groupButton:GetNormalTexture():SetVertexColor(unpack(((canCreateGroup[questID] == true) and (not inGroup)) and on or off))
			self.groupButton:GetPushedTexture():SetVertexColor(unpack(((canCreateGroup[questID] == true) and (not inGroup)) and on or off))

			shouldShow = shouldShow or showGroup

			local d = (((UnitInAnyGroup("player") == true) or shouldShow) and not self.groupButton:IsShown()) and self.groupButton:Show() or (self.groupButton:IsShown() and not shouldShow) and self.groupButton:Hide() --why not?
		
		
			if self.groupButton:IsShown() then
				QueueStatusMinimapButton:Hide()
			end
		
			return d
		end
		queued = nil
	end
